{ pkgs, ... }:

{
  imports = [
    ./hardware-configuration.nix
    ./networking.nix
    ./nginx.nix
  ];

  networking.hostId = "bbdd1133";
  networking.hostName = "thot";

  boot = {
    loader = {
      grub = {
        enable = true;
        zfsSupport = true;
        devices = [
          "/dev/disk/by-id/scsi-3600508b1001ca2198968a17f65ef3963"
          "/dev/disk/by-id/scsi-3600508b1001cd540705e8551011ec02d"
        ];
      };
    };

    zfs = {
      extraPools = [
        "head"
        "backups"
      ];
      forceImportAll = true;
    };
  };

  environment.systemPackages = with pkgs; [
    apacheHttpd
    restic
  ];

  crans = {
    enable = true;

    networking.adm.enable = false;
    resticClient.enable = false;

    services = {
      resticServer = {
        enable = true;
        port = 4242;
      };
    };
  };

  system.stateVersion = "24.05";
}
