{ config, lib, ... }:

let
  cfg = config.crans.monitoring;

  inherit (lib)
    mkEnableOption
    mkIf
    mkOption
    types
    ;
in

{
  options.crans.monitoring = {
    enable = mkEnableOption "Monitoring prometheus de la machine.";

    nginx = {
      enable = mkOption {
        type = types.bool;
        default = config.services.nginx.enable;
        example = true;
        description = "Monitoring de Nginx par prometheus.";
      };
    };
  };

  config = mkIf cfg.enable {
    services.prometheus.exporters = {
      node = {
        enable = true;
        port = 9100;

        openFirewall = true;
      };

      nginx = {
        enable = cfg.nginx.enable;
        port = 9117;
        scrapeUri = "http://[::1]:6424/stub_status";
      };
    };
  };
}
